# views.py

from django.http import JsonResponse
from django.views.decorators.csrf import csrf_exempt
from django.shortcuts import get_object_or_404

from products.models import Product
from stock.models import Stock 

@csrf_exempt
def adjust_stock(request):
    if request.method == 'POST':
        product_id = request.POST.get('product_id')
        quantity = int(request.POST.get('stockQuantity'))
        reason = request.POST.get('adjustmentReason')
        user = request.user

        product = get_object_or_404(Product, pk=product_id)

        try:
            previous_value = product.quantity_in_stock
            new_value = previous_value + quantity
            variance = quantity

            Stock.objects.create(
                previous_value=previous_value,
                new_value=new_value,
                variance=variance,
                product=product,
                updated_by=user,
                status='Pending'
            )

            product.quantity_in_stock = new_value
            product.save()

            return JsonResponse({'status': 'success', 'message': 'Stock adjusted successfully!'})
        except Exception as e:
            return JsonResponse({'status': 'error', 'message': str(e)})

    return JsonResponse({'status': 'error', 'message': 'Invalid request method'})
